      Program RmnFit
      Include 'RmnFit.prm'

      Open(11, file='out.txt', status='UNKNOWN', form='FORMATTED')
      Call RdPFC(7, 'fit.pfc')
      Call CalBG()
      Call Spctrm()
      Call LSQ()
      Call WrtSpctrm(8, 'fit.spc')
      Call CalArea()
      Call UpdtPrm(1, 'new.pfc')
      Close(11)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine CalArea()
      Include 'RmnFit.prm'
      
      Integer i
      Real*8 pi, CTot, fwhm, CoeG, CoeL
      
      pi = 3.1415926535d0
      CoeG = 1.064467019
      CoeL = 1.570796327
      Write(6,*)
      Write(11,*)
      Write(6,*) '[Peak Area]'
      Write(11,*) '[Peak Area]'
      Write(6,*) ' No. Pos.   C        FWHM       Area     Area(%)'
      Write(11,*) ' No. Pos.   C        FWHM       Area     Area(%)'
      TotArea = 0.0
      Do 10 i=1, nPeak
        Area(i) = CG(i)*FWHMG(i)*CoeG + CL(i)*FWHML(i)*CoeL
        TotArea = TotArea + Area(i)
   10 Continue
      Do 11 i=1, nPeak
        CTot = CG(i) + CL(i)
        fwhm = CG(i)/CTot*FWHMG(i) + CL(i)/CTot*FWHML(i)
        Write(6,'(i5,5g14.6)') i, wl0(i), CTot, fwhm,
     1                    Area(i), Area(i)/TotArea*100.0
        Write(11,'(i5,5g14.6)') i, wl0(i), CTot, fwhm,
     1                    Area(i), Area(i)/TotArea*100.0
   11 Continue
      End
c**********************************************************************
c
c**********************************************************************
      Real*8 Function CalS(X)
      Include 'RmnFit.prm'
      Real*8 X(*)
      Integer i, nParam

      nParam = 0
      Do 110 i=0, nBGOrder
        If(IdCBG(i) .eq. 1) Then
          nParam = nParam + 1
          CBG(i) = X(nParam)
        EndIf
  110 Continue
      Do 120 i=1, nPeak
        If(Idwl0(i) .eq. 1) Then
          nParam = nParam + 1
          wl0(i) = X(nParam)
        EndIf
        If(IdCG(i) .eq. 1) Then
          nParam = nParam + 1
          CG(i) = X(nParam)
        EndIf
        If(IdFWHMG(i) .eq. 1) Then
          nParam = nParam + 1
          FWHMG(i) = X(nParam)
        EndIf
        If(IdCL(i) .eq. 1) Then
          nParam = nParam + 1
          CL(i) = X(nParam)
        EndIf
        If(IdFWHML(i) .eq. 1) Then
          nParam = nParam + 1
          FWHML(i) = X(nParam)
        EndIf
  120 Continue

      CalS = 0.0d0
      Call Spctrm()
      Do 10 i=1, nData
        If((FitRng0 .le. wl(i)) .and. (wl(i) .le. FitRng1)) Then
          CalS = CalS + (IObs(i)-ICal(i))**2
        EndIf
   10 Continue
      Do 20 i=1, nPeak
        If((IdCG(i) .eq. 1) .and. (CG(i) .lt. 0.0d0)) Then
          CalS = CalS + 1.0d8*CG(i)*CG(i)
        EndIf
        If((IdFWHMG(i) .eq. 1) .and. (FWHMG(i) .lt. 1.0d0)) Then
          CalS = CalS + 1.0d8*(FWHMG(i)-1.0d0)**2
        EndIf
        If((IdCL(i) .eq. 1) .and. (CL(i) .lt. 0.0d0)) Then
          CalS = CalS + 1.0d8*CL(i)*CL(i)
        EndIf
        If((IdFWHML(i) .eq. 1) .and. (FWHML(i) .lt. 1.0d0)) Then
          CalS = CalS + 1.0d8*(FWHML(i)-1.0d0)**2
        EndIf
   20 Continue
      Do 30 i=1, nData
        If((FitRng0 .le. wl(i)) .and. (wl(i) .le. FitRng1)) Then
          If(BG(i) .lt. 0.0d0) Then
            CalS = CalS + 1.0e8*BG(i)**2
          EndIf
        EndIf
   30 Continue
      Return
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine LSQ()
      Include 'RmnFit.prm'
      External CalS
      
      Real*8 X(MParam), DX(MParam)
      Real*8 Avrg
      Integer nParam
      Integer i
      Integer nSData

      nParam = 0
      Do 10 i=0, nBGOrder
        If(IdCBG(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = CBG(i)
          DX(nParam) = DXCBG(i)
        EndIf
   10 Continue
      Do 20 i=1, nPeak
        If(Idwl0(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = wl0(i)
          DX(nParam) = DXwl0(i)
        EndIf
        If(IdCG(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = CG(i)
          DX(nParam) = DXCG(i)
        EndIf
        If(IdFWHMG(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = FWHMG(i)
          DX(nParam) = DXFWHMG(i)
        EndIf
        If(IdCL(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = CL(i)
          DX(nParam) = DXCL(i)
        EndIf
        If(IdFWHML(i) .eq. 1) Then
          nParam = nParam + 1
          X(nParam) = FWHML(i)
          DX(nParam) = DXFWHML(i)
        EndIf
   20 Continue

      Write(6,*)
      Write(11,*)
      Write(6,*) '[***Start SMPLX]'
      Write(11,*) '[***Start SMPLX]'
      Call SMPLX(CalS, X, DX, TolX, TolF, nParam, FMin, nMaxIntvl,
     1           iPrt, iPrtIntvl)

      nParam = 0
      Do 110 i=0, nBGOrder
        If(IdCBG(i) .eq. 1) Then
          nParam = nParam + 1
          CBG(i) = X(nParam)
        EndIf
  110 Continue
      Do 120 i=1, nPeak
        If(Idwl0(i) .eq. 1) Then
          nParam = nParam + 1
          wl0(i) = X(nParam)
        EndIf
        If(IdCG(i) .eq. 1) Then
          nParam = nParam + 1
          CG(i) = X(nParam)
        EndIf
        If(IdFWHMG(i) .eq. 1) Then
          nParam = nParam + 1
          FWHMG(i) = X(nParam)
        EndIf
        If(IdCL(i) .eq. 1) Then
          nParam = nParam + 1
          CL(i) = X(nParam)
        EndIf
        If(IdFWHML(i) .eq. 1) Then
          nParam = nParam + 1
          FWHML(i) = X(nParam)
        EndIf
  120 Continue
      
      nSData = 0
      Avrg = 0.0
      Do 210 i=1, nData
        If((FitRng0 .le. wl(i)) .and. (wl(i) .le. FitRng1)) Then
          nSData = nSData + 1
          Avrg = Avrg + IObs(i)
        EndIf
  210 Continue
      Avrg = Avrg/nSData
      Sum = FMin
      Srms = dsqrt(Sum/(nSData-1)) / Avrg * 100.0
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine WrtSpctrm(ifile, fname)
      Include 'RmnFit.prm'
      Integer ifile
      Character*(*) fname

      Integer i
      Integer nSData
      nSData = 0
      Do 10 i=1, nData
        If((FitRng0 .le. wl(i)) .and. (wl(i) .le. FitRng1)) Then
          nSData = nSData + 1
        EndIf
   10 Continue
      Open(ifile, file=fname, form='FORMATTED', status='UNKNOWN')
      Write(ifile, '(a30)') OrgFile
      Write(ifile, *) nSData
      Do 20 i=1, nData
        If((FitRng0 .le. wl(i)) .and. (wl(i) .le. FitRng1)) Then
          If(nPeak .eq. 1) Then
            Write(ifile, '(f12.6, 4f10.4)') wl(i), IObs(i), BG(i), 
     1                     ICal(i), IPeak(1,i)
          Else If(nPeak .eq. 2) Then
            Write(ifile, '(f12.6,5f10.4)') wl(i), IObs(i), BG(i),
     1                     ICal(i), IPeak(1,i), IPeak(2,i)
          Else If(nPeak .eq. 3) Then
            Write(ifile, '(f12.6, 6f10.4)') wl(i), IObs(i), BG(i),
     1                     ICal(i), IPeak(1,i), IPeak(2,i), IPeak(3,i)
          Else If(nPeak .eq. 4) Then
            Write(ifile, '(f12.6, 7f10.4)') wl(i), IObs(i), BG(i),
     1                     ICal(i), IPeak(1,i), IPeak(2,i), 
     2                     IPeak(3,i), IPeak(4,i)
          Else If(nPeak .eq. 5) Then
            Write(ifile, '(f12.6, 8f10.4)') wl(i), IObs(i), BG(i),
     1                     ICal(i), IPeak(1,i), IPeak(2,i),
     2                      IPeak(3,i), IPeak(4,i), IPeak(5,i)
          Else If(nPeak .eq. 6) Then
            Write(ifile, '(f12.6, 9f10.4)') wl(i), IObs(i), BG(i),
     1                     ICal(i), IPeak(1,i), IPeak(2,i),
     2                     IPeak(3,i), IPeak(4,i), IPeak(5,i),
     3                     IPeak(6,i)
          EndIf  
        EndIf
   20 Continue
      Close(ifile)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine Spctrm()
      Include 'RmnFit.prm'
      
      Integer i, j
      Real CoeG, CoeL
      
      CoeG = 2.772588722
      CoeL = 4.0
      
      Call CalBG()
      Do 100 j=1, nPeak
        Do 110 i=1, nData
          IPeak(j,i) =
     1        CG(j)*DExp(-CoeG*((wl(i)-wl0(j))/FWHMG(j))**2)
     2      + CL(j)/(1.0d0+CoeL*((wl(i)-wl0(j))/FWHML(j))**2)
  110   Continue
  100 Continue
      Do 10 i=1, nData
        ICal(i) = BG(i)
        Do 20 j=1, nPeak
          ICal(i) = ICal(i)+IPeak(j,i)
   20   Continue
c       write(6,*) i,ical(i)
   10 Continue
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine CalBG()
      Include 'RmnFit.prm'
      
      Integer i, j
      Real*8 Cent, Rng
      
      Cent = (FitRng0+FitRng1)/2.0d0
      Rng = (FitRng1-FitRng0)/2.0d0
      Do 10 i=1, nData
        BG(i) = CBG(0)
        Do 20 j=1, nBGOrder
          BG(i) = BG(i) + CBG(j)*((wl(i)-Cent)/Rng)**j
   20   Continue
   10 Continue
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine RdPFC(ifile, fname)
      Include 'RmnFit.prm'
      Integer ifile
      Character*(*) fname
      
      Integer i
      
      Write(6,'(a30)') '[Read file from ', fname, ' ]'
      Write(11,'(a30)') '[Read file from ', fname, ' ]'
      Open(ifile, file=fname, form='FORMATTED', status='OLD')
      Read(ifile,'(a79)') OrgFile
      Write(6,'(a79)') OrgFile
      Write(11,'(a79)') OrgFile
      Read(ifile, *) iPrt, iPrtIntvl
      Write(6,*) 'iPrt, iPrtIntvl: ', iPrt, iPrtIntvl
      Write(11,*) 'iPrt, iPrtIntvl: ', iPrt, iPrtIntvl
      Read(ifile, *) nMaxIntvl, TolX, TolF
      Write(6,*) nMaxIntvl, TolX, TolF
      Write(11,*) nMaxIntvl, TolX, TolF
      Read(ifile,*) FitRng0, FitRng1
      Write(6,*) FitRng0, FitRng1
      Write(11,*) FitRng0, FitRng1
      Read(ifile,*) nBGOrder
      Write(6,*) nBGOrder
      Write(11,*) nBGOrder
      Do 10 i=0, nBGOrder
        Read(ifile,*) CBG(i), IdCBG(i), DXCBG(i)
        Write(6,*) '   ', CBG(i), IdCBG(i), DXCBG(i)
        Write(11,*) '   ', CBG(i), IdCBG(i), DXCBG(i)
   10 Continue
      Read(ifile,*) nPeak
      Write(6,*) nPeak
      Write(11,*) nPeak
      Do 20 i=1, nPeak
        Read(ifile,*) wl0(i), Idwl0(i), DXwl0(i)
        Write(6,*) '   ', wl0(i), Idwl0(i), DXwl0(i)
        Write(11,*) '   ', wl0(i), Idwl0(i), DXwl0(i)
        Read(ifile,*) CG(i), IdCG(i), DXCG(i)
        Write(6,*) '   ', CG(i), IdCG(i), DXCG(i)
        Write(11,*) '   ', CG(i), IdCG(i), DXCG(i)
        Read(ifile,*) FWHMG(i), IdFWHMG(i), DXFWHMG(i)
        Write(6,*) '   ', FWHMG(i), IdFWHMG(i), DXFWHMG(i)
        Write(11,*) '   ', FWHMG(i), IdFWHMG(i), DXFWHMG(i)
        Read(ifile,*) CL(i), IdCL(i), DXCL(i)
        Write(6,*) '   ', CL(i), IdCL(i), DXCL(i)
        Write(11,*) '   ', CL(i), IdCL(i), DXCL(i)
        Read(ifile,*) FWHML(i), IdFWHML(i), DXFWHML(i)
        Write(6,*) '   ', FWHML(i), IdFWHML(i), DXFWHML(i)
        Write(11,*) '   ', FWHML(i), IdFWHML(i), DXFWHML(i)
   20 Continue
      Read(ifile,*) Sum, Srms
      Write(6,*) Sum, Srms
      Write(11,*) Sum, Srms
      Read(ifile,*) nData
      Write(6,*) nData
      Write(11,*) nData
      Do 30 i=1, nData
        Read(ifile,*) wl(i), IObs(i)
c        Write(6,*) '   ', wl(i), IObs(i)
   30 Continue
      Close(ifile)
      End
c**********************************************************************
c
c**********************************************************************
      Subroutine UpdtPrm(ifile, fname)
      Include 'RmnFit.prm'
      Integer ifile
      Character*(*) fname
      
      Integer i
      
      Write(6,'(a30)') '[Save new pameters to ', fname, ' ]'
      Write(11,'(a30)') '[Save new pameters to ', fname, ' ]'
      Open(ifile, file=fname, form='FORMATTED', status='UNKNOWN')
      Write(ifile,'(a79)') OrgFile
      Write(ifile,*) iPrt, iPrtIntvl
      Write(ifile, '(i5,2g16.4)') nMaxIntvl, Real(TolX), Real(TolF)
      Write(ifile,*) Real(FitRng0), Real(FitRng1)
      Write(ifile,*) nBGOrder
      Do 10 i=0, nBGOrder
        Write(ifile,*) '   ', CBG(i), IdCBG(i), DXCBG(i)
   10 Continue
      Write(ifile,*) nPeak
      Do 20 i=1, nPeak
        Write(ifile,*) '   ', Real(wl0(i)), Idwl0(i), DXwl0(i)
        Write(ifile,*) '   ', Real(CG(i)), IdCG(i), DXCG(i)
        Write(ifile,*) '   ', Real(FWHMG(i)), IdFWHMG(i), DXFWHMG(i)
        Write(ifile,*) '   ', Real(CL(i)), IdCL(i), DXCL(i)
        Write(ifile,*) '   ', Real(FWHML(i)), IdFWHML(i), DXFWHML(i)
   20 Continue
      Write(ifile,'(2g16.6)') Real(Sum), Real(Srms)
      Write(ifile,*) nData
      Do 30 i=1, nData
        Write(ifile,'(a,2g16.6)') '   ', Real(wl(i)), Real(IObs(i))
   30 Continue
      Write(ifile,*)
      Write(ifile,*) '[Peak Area]'
      Do 100 i=1, nPeak
        Write(ifile,*) i, Real(wl0(i)), Real(Area(i))
  100 Continue
      Close(ifile)
      End