from scipy.optimize import minimize


method = "nelder-mead"


#==========================================
# Source parameters to be fitted
#==========================================
x0s = [0.0, 0.0]

maxiter = 100
tol = 1.0e-5


def minimize_func(x):
    return 2.0 * (x[0] - 3.0)**2 + (x[1] - 1.0)**4 + 2.0
    
#==========================================
# Main routine
#==========================================
def main():
    global x0s, tol, maxiter
    
    print("")
    print(f"method {method}")
    print(f"initial values {x0s}")
    print(f"tol {tol}")

    print("")
    print("Minimize:")
    res = minimize(minimize_func, x0s, method = method, tol = tol, options = {'maxiter':maxiter, "disp":True})
#    print("")
#    print(res)
    print("")
    if res.success:
        print(f"Function takes the minimum")
        print(f"   at y={res.fun}")
        print(f"   with x={res.x}")
        print(f" iteration: {res.nit}")
    else:
        print(f"Function did not converge")
        print(res)

if __name__ == "__main__":
    main()
